/*  GWhere.
 *  Copyright (C) 2000  1999 by Balzs Ternyi
 *  Modified Sbastien LECACHEUR
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "tools/gwtools.h"


char * g_module_check_init ( void)
{
#ifdef __DEBUG__
	printf ( "HTML module is loading...\n");
#endif

	return NULL;
}


const char * plugin_get_author ( void)
{
	return "Sbastien LECACHEUR";
}


const char * plugin_get_info ( void)
{
	return "This plugin allow to extract title from HTML file.";
}


const char * plugin_get_help ( void)
{
	return NULL;
}


const char * plugin_get_allowed_ext ( void)
{
	return "html|htm";
}


char * plugin_get_descr ( const char *filepath, const char *mode)
{
	char *descr = NULL, *tmp_descr = NULL;
	FILE *file = NULL;
	int len,title_len;
	char *title_start = NULL;
	char buff[512];
	char buff_original[512];
	char databuff[2048];
	char databuff_lower[2048];
	gboolean found = FALSE;
	gboolean finish = FALSE;


	if ( filepath != NULL )
	{
		if ( (file = fopen ( filepath, "rb")) != NULL ) {
			while ( (fgets ( buff_original, 512, file) != 0) && (!finish) )
			{
				strcpy ( buff, buff_original);
				gw_str_to_lower ( buff);

				if ( (title_start = strstr ( buff, "<title>")) != 0)
				{
					strcpy ( databuff, &buff_original[title_start - &buff[0] + 7]);
					found = TRUE;
				}

				if ( (strstr ( buff, "<title>") == 0) && found )
				{
					if ( strlen ( databuff) + strlen ( buff_original) < 2048)
					{
						strcat ( databuff, buff_original);
					}
					else
					{
						fclose ( file);
						return 0;
					}
				}

				if ( strstr ( buff, "</title>") != 0)
				{
					strcpy ( databuff_lower, databuff);
					gw_str_to_lower ( databuff_lower);

					len = strstr ( databuff_lower, "</title>") - databuff_lower;

					if ( len > 0 )
					{
						descr = (char*)g_malloc ( len + 1);
						descr[0] = '\0';
						memset(descr,'\0',len+1);
						strncpy ( databuff_lower, databuff, len);
						databuff_lower[len] = '\0';
						databuff_lower[len+1] = '\0';
						strncpy ( descr, databuff_lower, strlen ( databuff_lower));
						tmp_descr = gw_str_replace_str ( descr, "\r\n", " ");
						g_free ( descr);
						descr = tmp_descr;
						gw_str_replace_char ( descr, '\n', ' ');
						gw_str_delete_char ( descr, '\t');
						finish = TRUE;
					}
					else
					{
						finish = TRUE;
					}
				}

				if ( strstr ( buff, "</head>") != 0)
				{
					finish = TRUE;
				} else if ( strstr ( buff, "<body>") != 0)
				{
					finish = TRUE;
				}
			}

			fclose ( file);
		}
	}

	return descr;
}


void g_module_unload ( void)
{
#ifdef __DEBUG__
	printf ( "HTML module is unloading...\n");
#endif
}
